// ============================================================================
// ==                                                                        ==
// == AMDiS - Adaptive multidimensional simulations                          ==
// ==                                                                        ==
// ============================================================================
// ==                                                                        ==
// ==  crystal growth group                                                  ==
// ==                                                                        ==
// ==  Stiftung caesar                                                       ==
// ==  Ludwig-Erhard-Allee 2                                                 ==
// ==  53175 Bonn                                                            ==
// ==  germany                                                               ==
// ==                                                                        ==
// ============================================================================
// ==                                                                        ==
// ==  http://www.caesar.de/cg/AMDiS                                         ==
// ==                                                                        ==
// ============================================================================

/** \file AMDiS_fwd.h */


#ifndef AMDIS_AMDIS_FWD_INCLUDE
#define AMDIS_AMDIS_FWD_INCLUDE

namespace AMDiS {

  class AdaptInfo;
  class AdaptStationary;
  class BasisFunction; 
  class BoundaryManager;
  class CGSolver;
  class CoarseningManager;
  class DiagonalPreconditioner; 
  class DOFAdmin; 
  class DOFMatrix;
  class Element;
  class ElementMatrix;
  class ElementVector;
  class ElInfo; 
  class Estimator;
  class FastQuadrature;
  class FillInfo; 
  class FileWriterInterface;
  class FiniteElemSpace; 
  class IdentityPreconditioner; 
  class ITL_BasePreconditioner;
  class LeafDataPeriodic;
  class LevelAdmin;
  class Marker;
  class Mesh; 
  class OEMSolver;
  class Operator;
  class ProblemInstat;
  class ProblemIterationInterface;
  class ProblemVec;
  class PreconditionerScal;
  class Quadrature; 
  class RCNeighbourList;
  class RefinementManager;
  class RobinBC;
  class SystemVector;
  class VertexVector;

  template<typename ReturnType, typename ArgumentType> class AbstractFunction;
  template<typename T>                                 class DOFVectorBase;
  template<typename T>                                 class DOFVector;
  template<typename T>                                 class ITL_Preconditioner;
  template<typename T>                                 class Matrix;
  template<typename T>                                 class MatVecMultiplier;
  template<typename T>                                 class SolverMatrix;
  template<typename T>                                 class Vector;
  template<typename T>                                 class WorldVector;

  template <typename ITLSolver>    class ITL_OEMSolver;

} // namespace AMDiS

#endif // AMDIS_AMDIS_FWD_INCLUDE
